#include "Daemoninstaller.h"
#include "util/Downloader.h"
#include "util/SystemCall.h"
#include <QDir>

namespace installer {

using namespace util;

Daemoninstaller::Daemoninstaller()
// don't delete the following line as it's needed to preserve source code of this autogenerated element
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E35 begin
{
    downloadPath=QDir::home().path().append(QDir::separator());
    //downloadPath.append("tmp").append(QDir::separator());

    if(QSysInfo::WordSize==64)
        daemonUrl="http://www.dropbox.com/download?plat=lnx.x86_64";
    else
        daemonUrl="http://www.dropbox.com/download?plat=lnx.x86";

}
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E35 end
// don't delete the previous line as it's needed to preserve source code of this autogenerated element

void Daemoninstaller::downloadDaemon()
// don't delete the following line as it's needed to preserve source code of this autogenerated element
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E80 begin
{
    Downloader *d= new Downloader(this->daemonUrl,"daemon.tar.gz");
    d->set_downloadpath(downloadPath);
    connect(d,SIGNAL(fileDownloaded()),this,SLOT(onFileDownloaded()));
    form = new InstallerForm();
    form->show();
    connect(d,SIGNAL(downloadProgress(int)),this,SLOT(onDownloadProgressChange(int)));
    d->download();
}
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E80 end
// don't delete the previous line as it's needed to preserve source code of this autogenerated element

void Daemoninstaller::extract()
// don't delete the following line as it's needed to preserve source code of this autogenerated element
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E86 begin
{
    SystemCall *sc = new SystemCall();
    sc->setWorkingDirectory(downloadPath);
    downloadPath.append("daemon.tar.gz");
    //qt_message_output(QtWarningMsg,"Extracting...\ntar -xvf "+downloadPath.toLatin1());
    sc->execute("tar -xf "+downloadPath);
    sc->waitForFinished();
    sc->close();
    executeWizzard();

}
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E86 end
// don't delete the previous line as it's needed to preserve source code of this autogenerated element

void Daemoninstaller::executeWizzard()
// don't delete the following line as it's needed to preserve source code of this autogenerated element
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E88 begin
{
    SystemCall *sc = new SystemCall();
    sc->executeDetached(QDir::home().path().append(QDir::separator()).append(".dropbox-dist/dropboxd"));
    sc->waitForStarted();
    preventGtkGuiExecution();
    //sc->close();
}
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E88 end
// don't delete the previous line as it's needed to preserve source code of this autogenerated element

void Daemoninstaller::preventGtkGuiExecution()
// don't delete the following line as it's needed to preserve source code of this autogenerated element
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E8A begin
{
    SystemCall *sc = new SystemCall();
    //sc->setWorkingDirectory(QDir::home().path());
    form->hide();
    form->~InstallerForm();
    sleep(5);
    QString path=QDir::home().path().append(QDir::separator());
    sc->executeDetached("mv "+path+".dropbox-dist/wx._controls_.so "+path+".dropbox-dist/wx._controls_orig.so");
    sc->executeDetached("rm "+ downloadPath);
    //sc->close();
    quick_exit(1);
}
// section 127-0-0-2-50c13b42:1288dba840f:-8000:0000000000000E8A end
// don't delete the previous line as it's needed to preserve source code of this autogenerated element

void Daemoninstaller::onFileDownloaded(){
    extract();
}

void Daemoninstaller::onFileExtracted(int i){
   qt_message_output(QtWarningMsg,tr("File extracted").toLatin1());
}

void Daemoninstaller::onDownloadProgressChange(int i){
    form->setProgressValue(i);

}

} /* End of namespace installer */
